;****************************************************************
;* :				Megavolt								*
;* :				16/11/2009 .							*
;* :				1.1										*
;*  :			Dyn_indic_key							*
;*  AVR:				ATtiny2313								*
;*  :	6 									*
;****************************************************************

;  :   +  
;__________________________________________________________________________

.device	ATtiny2313
.nolist
.include "d:\avr\def\tn2313def.inc"
.list

;=====================================================================
; :


.def 	key_mem_reg=r1
.def	temp1=r2
.def	n_digit=r3
.def	counter=r4
.def	digit_out=r5
.def 	n_point=r6
.def	temp=r16
.def	temp2=r17



.equ	crystal=6000000					; 
.equ	Sciler=1024						; 
.equ	N_TC0_2500uc=255-crystal/(Sciler*400);   0  
										;  
.equ    amount_digit=4					;,     
										;   4-  




;======================================================================
;  :

.dseg

Digit:		.byte 4
Point:		.byte 1
Key:		.byte 8

.cseg
.org 0
		rjmp RESET						;Reset Handler
		nop ;rjmp INT0						;External Interrupt0
		nop ;rjmp INT1					;External Interrupt1
		nop ;rjmp ICP1     				;Input capture interrupt 1
		nop ;rjmp OC1A   				;Timer/Counter1 Compare Match A     
		nop ;rjmp OVF1  				;Overflow1 Interrupt 
		rjmp OVF0     					;Overflow0 Interrupt
		nop ;rjmp URXC0     			;USART0 RX Complete Interrupt
		nop ;rjmp UDRE0     			;USART0 Data Register Empty Interrupt
		nop ;rjmp UTXC0     			;USART0 TX Complete Interrupt 
		nop ;rjmp ACI     				;Analog Comparator Interrupt 
		nop ;rjmp PCINT     			;Pin Change Interrupt
		nop ;rjmp OC1B     				;Timer/Counter1 Compare Match B
		nop ;rjmp OC0A     				;Timer/Counter0 Compare Match A     
		nop ;rjmp OC0B     				;Timer/Counter0 Compare Match B     
		nop ;rjmp USI_START     		;USI start interrupt
		nop ;rjmp USI_OVF     			;USI overflow interrupt
		nop ;rjmp ERDY     				;EEPROM write complete
		nop ;rjmp WDT     				;Watchdog Timer Interrupt
										; for compatibility purpose




;======================================================================
; 

	RESET:
		ldi temp,low (RAMEND)			;  
		out SPL,temp

		ldi temp,0b0001111				; 
		out DDRD,temp					; D \
		ser temp
		out DDRB,temp					; B 	
		out PIND,temp					;  
		out PORTD,temp					;  
		out PORTB,temp					; 

		ldi temp,15						;  
		out WDTCR,temp
		rcall TNCT_0					;  0


;======================================================================
;         1234
;    
		ldi Temp,4
		sts Digit  ,Temp      			;    4321
		ldi Temp,3
		sts Digit+1,Temp
		ldi Temp,2
		sts Digit+2,Temp
		ldi Temp,1
		sts Digit+3,Temp
	
		ldi Temp,1
		sts Point,Temp      			;    2- 
		clr counter
;======================================================================
;      
; 
		ldi Temp,0
		sts Key,Temp      			;      
		ldi Temp,0
		sts Key+1,Temp
		ldi Temp,0
		sts Key+2,Temp
		ldi Temp,0
		sts Key+3,Temp
		ldi Temp,0
		sts Key+4,Temp      			;      
		ldi Temp,0
		sts Key+5,Temp
		ldi Temp,0
		sts Key+6,Temp
		ldi Temp,0
		sts Key+7,Temp




;======================================================================
;   

	main:

		wdr								;"  "
	


		rjmp main						;  
		 

;=======================================================================
;  		
	
	TNCT_0:
		cli								; 
		ldi temp,N_TC0_2500uc			;   \0  =0,0025 
		out TCNT0,temp
		ldi temp,0b00000000
		out TCCR0A,temp
		ldi temp,(1<<CS02)+(1<<CS00)	;  1024
		;ldi temp,(1<<CS00)				;  1  
		out TCCR0B,temp
		ldi temp,(1<<TOIE0)			 	; \0  
		out TIMSK,temp
		sei
		reti



;========================================================================
;  
	
	OVF0:
		rcall TNCT_0					;  0
		ldi ZL,Low(Digit)   			; 
        ldi ZH,High(Digit)
		clr temp1
		add ZL,counter					;   
		adc ZH,temp1
		ld digit_out,Z      			; 
		lds	n_point,Point
		rcall Decoder_n_digit
		rcall Decoder
		out PORTD,n_digit
		out PORTB,digit_out
		rcall Check_key
		inc counter						;  
		mov temp,counter
		andi temp,(amount_digit-1)	;    
		mov counter,temp
	
		reti 
	
	
;=========================================================================
; 	
	Decoder:
	;     7-   		
			
           	clr temp		
			ldi ZL,Low(DcMatrix*2)   	;  
            ldi ZH,High(DcMatrix*2)
			clr temp1	             	; 
            add ZL,digit_out        	; 0-  
            adc ZH,temp1
            lpm                     	;  7-   
            mov digit_out,r0
			clr temp
			cp n_point,temp				;     
			breq PC+6					;   0    
			cp counter,n_point			;       
			brne PC+4					;     
			mov temp,digit_out
			andi temp,0b01111111		;    
          	mov digit_out,temp  
			ret							;  




	DcMatrix:
	; -   
		;     hgfedcba   hgfedcba
		.db 0b11000000,0b11111001		;0;1
		.db 0b10100100,0b10110000		;2;3
		.db 0b10011001,0b10010010		;4;5
		.db 0b10000010,0b11111000		;6;7
		.db 0b10000000,0b10010000		;8;9
	

	
	Decoder_n_digit:
			ldi ZL,Low(DnMatrix*2)   	; 
            ldi ZH,High(DnMatrix*2)
            clr temp1	             	; 
            add ZL,counter            	; 0-  
            adc ZH,temp1
            lpm                     	; 
            mov n_digit,r0
            ret


	DnMatrix:
	; -    
		
		.db 0b11111110,0b11111101	;0;1
		.db 0b11111011,0b11110111	;2;3

		



	Check_key:

			ldi XL,Low(Key)   				;  
        	ldi XH,High(Key)
			inc temp2
			andi temp2,0b00000111			;    
			add XL,temp2					;  8 
			ld temp,X
			cpi temp,0
			breq PC+3
			dec temp
			st X,temp
					
			in temp,PIND
			andi temp,0b00110000
			cpi	temp,0b00110000
			breq End_Decoder_key
			add temp,counter
			
			cpi temp,0b00010000
			brne PC+2
			jmp Set_key1
			

			cpi temp,0b00010001
			brne	PC+2
			jmp Set_key2
			

			cpi temp,0b00010010
			brne	PC+2
			jmp Set_key3

			cpi temp,0b00010011
			brne	PC+2
			jmp Set_key4

			cpi temp,0b00100000
			brne	PC+2
			jmp Set_key5

			cpi temp,0b00100001
			brne	PC+2
			jmp Set_key6

			cpi temp,0b00100010
			brne	PC+2
			jmp Set_key7

			cpi temp,0b00100011
			brne	PC+2
			jmp Set_key8

			
	End_Decoder_key:

			ret



;  


		Set_key1:
			
			lds temp,Key
			cpi temp,0
			breq PC+2
			ret
			ldi temp,64
			sts Key,temp
			lds temp,Digit
			inc temp
			cpi temp,10
			brne PC+2
			ldi temp,0
			sts Digit,temp		
			ret


		Set_key2:

			lds temp,Key+1
			cpi temp,0
			breq PC+2
			ret
			ldi temp,64
			sts Key+1,temp
			lds temp,Digit+1
			inc temp
			cpi temp,10
			brne PC+2
			ldi temp,0
			sts Digit+1,temp	
			ret



		Set_key3:
			lds temp,Key+2
			cpi temp,0
			breq PC+2
			ret
			ldi temp,64
			sts Key+2,temp
			lds temp,Digit+2
			inc temp
			cpi temp,10
			brne PC+2
			ldi temp,0
			sts Digit+2,temp		
			ret

	Set_key4:
			lds temp,Key+3
			cpi temp,0
			breq PC+2
			ret
			ldi temp,64
			sts Key+3,temp
			lds temp,Digit+3
			inc temp
			cpi temp,10
			brne PC+2
			ldi temp,0
			sts Digit+3,temp
			ret



	Set_key5:
			lds temp,Key
			cpi temp,0
			breq PC+2
			ret
			ldi temp,64
			sts Key,temp
			lds temp,Digit
			dec temp
			cpi temp,255
			brne PC+2
			ldi temp,9
			sts Digit,temp	
			ret



	Set_key6:
			lds temp,Key+1
			cpi temp,0
			breq PC+2
			ret
			ldi temp,64
			sts Key+1,temp
			lds temp,Digit+1
			dec temp
			cpi temp,255
			brne PC+2
			ldi temp,9
			sts Digit+1,temp	
			ret


	Set_key7:
			lds temp,Key+2
			cpi temp,0
			breq PC+2
			ret
			ldi temp,64
			sts Key+2,temp
			lds temp,Digit+2
			dec temp
			cpi temp,255
			brne PC+2
			ldi temp,9
			sts Digit+2,temp	
			ret


	Set_key8:
			lds temp,Key+3
			cpi temp,0
			breq PC+2
			ret
			ldi temp,64
			sts Key+3,temp
			lds temp,Digit+3
			dec temp
			cpi temp,255
			brne PC+2
			ldi temp,9
			sts Digit+3,temp	
			ret









